//
//  LetsGameActivityAPI.m
//  GameActivitySDK
//
//  Created by yanglele on 2018/6/11.
//  Copyright © 2018年 alexYang. All rights reserved.
//

#import "LetsGameActivityAPI.h"
#import "LSGGameActivityViewController.h"

@interface LetsGameActivityAPI()

@property(nonatomic, assign) BOOL isShowed;
@property(nonatomic, strong) UINavigationController *navigationController;

@end

@implementation LetsGameActivityAPI
+(instancetype)instance{
    static LetsGameActivityAPI *__single__;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        __single__ = [[LetsGameActivityAPI alloc] init];
    });
    return __single__;
}

-(void)decideIsDebug:(int)isDebug{
    self.isDebug = isDebug;
}

-(void)GameActivityWithParaDictory:(NSDictionary *)paraDictory handleCallBackL:(void(^)())accomplistCallBack{
    LSGGameActivityViewController *gameActivityVC = [[LSGGameActivityViewController alloc] init];
    gameActivityVC.appId = paraDictory[@"appId"];
    gameActivityVC.appKey = paraDictory[@"appKey"];
    gameActivityVC.userId = paraDictory[@"userId"];
    gameActivityVC.serverId = paraDictory[@"serverId"];
    gameActivityVC.serverName = paraDictory[@"serverName"];
    gameActivityVC.roleId = paraDictory[@"roleId"];
    gameActivityVC.roleName = paraDictory[@"roleName"];
    gameActivityVC.diamond = paraDictory[@"diamond"];
    
    gameActivityVC.accomplistCallBack = accomplistCallBack;
    
    gameActivityVC.isDebug = self.isDebug;
    self.navigationController = [[UINavigationController alloc] initWithRootViewController:gameActivityVC];
    [self show:[UIApplication sharedApplication].delegate.window];
    
}

- (void)hide {
    [self.navigationController popToRootViewControllerAnimated:NO];
    [self.navigationController.view removeFromSuperview];
    self.navigationController = nil;
    self.isShowed = NO;
}

- (void)show:(UIView *)view {
    if (self.isShowed) {
        return;
    }
    
    [view addSubview:self.navigationController.view];
    self.isShowed = YES;
}
@end
